<?php
/**
 * Description of Usuario
 *
 * @author carlos
 */

class TicketEntity Extends TicketRepository{
    private $options = array(
        'sucursal'=>null,
        'fecha'=>null,
        'ticket'=>null,
        'total'=>null,
        'forma_de_pago'=>null,        
        'num_cuenta_pago'=>null,
        'status'=>null
    );
    
    private $options_factura = array(    
        'sucursal'=>null,
        'ticket'=>null,
        'total'=>null,
        'forma_de_pago'=>null,        
        'num_cuenta_pago'=>null,
        'status'=>'1',
        'tipo_documento'=>'I',
        'condiciones_de_pago'=>'Contado', 
        'metodo_de_pago'=>'PUE', 
        'uso_cfdi'=>'G03',
        'moneda'=>'MXN',
        'tipo_de_cambio'=>'1.0',
        'id_cliente'=>null,  
        'subtotal'=>null,   
        'descuento'=>'0',
        'total_impuestos_trasladados'=>null,
        'total_impuestos_retenidos'=>null,
        'detalles_impuestos_aplicables'=>null
    );
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
    }
    
    public function setOptionsFactura($data){
      foreach ($this->options_factura as $option => $value){
          if(isset($data[$option])){
            $this->options_factura[$option] = $data[$option];
          }
      }
    }
  
    public function getOptions(){
        return $this->options;
    }
    
    public function getOptionsFactura(){
        return $this->options_factura;
    }
    
    public function getDatosTicket($options = null) {
        return parent::getDatosTicket($this->options);
    }
    
    public function getIdSucursalParaSistema($sucursal){
        $sucursalesEnCarls = array('1'=>'7869 Hidalgo','2'=>'7870 Morelos','3'=>'8501 Matamoros','4'=>'8070 Periferico Exterior','5'=>'7942 Aeropuerto','6'=>'7923 Periferico Interior','7'=>'7879 Reforma');
        $sucursalesEnSistema = array('1'=>'7869 Hidalgo','2'=>'7870 Morelos','3'=>'8501 Matamoros','4'=>'8070 Periferico Exterior','5'=>'7942 Aeropuerto','6'=>'7923 Periferico Interior','7'=>'7879 Reforma');
        
        $sucursales = array(
            '1'=>'3',
            '2'=>'4',
            '3'=>'8',
            '4'=>'2',
            '5'=>'5',
            '6'=>'6',
            '7'=>'7',
        );
        
        return $sucursales[$sucursal];
    }
    
    public function facturarTicket($data){                       
        $repo = new EntityRepository();
        $settings = new SettingsEntity();
        //$cliente = new ClienteEntity();
        $cliente = new ClienteRepository();
        $cliente->setOptions($data);
        
        /* Agregar o Actualizar informacion de cliente*/
        if(trim($data['id_cliente']) != '' && $data['id_cliente'] != null ){
            $cliente->update($data['id_cliente'], $cliente->getOptions());
            $idCliente = $data['id_cliente'];            
        }else{
            $cliente->save($cliente->getOptions());
            $idCliente = $cliente->getInsertId();
        }

        $data['id_cliente'] = $idCliente;         
        
        /*Preparar informacion para Factura*/        
        #$data = Datos que se ingresan los cliente que estan facturando ticket
        #fecha,sucursal,id_ticket,total_ticket,forma_de_pago,num_cuenta_pago
        $this->setOptionsFactura($data);        
        $datosFactura = $this->getOptionsFactura(); 
        
        # $datosTicketFromDB = Datos que se almacena cuando se genera la venta en tienda  
        $datosTicketFromDB = $this->getById($data['id_ticket_table']);            
        $detalles = $this->getTicketDetallesByNoTicket($data['ticket']); 
        
        
        if(is_null($detalles)){
            $defaultProductToInvoice = $settings->_get('default_product_id_to_invoice');
            $defaultImpuestoToInvoice = $settings->_get('default_impuesto_id_to_invoice');
            $defaultProductData = $repo->getById($defaultProductToInvoice,'productos');            
            $impuestosData = $repo->getById($defaultImpuestoToInvoice,'impuestos');

            $totalFactura = $datosTicketFromDB['monto'];
            $precio = $totalFactura/(1 + $impuestosData['tasa_cuota']/100 );
            $precio = round($precio,2);
            $impuestosMonto = $totalFactura - $precio;
            
            $result = $repo->query("SELECT descripcion FROM unidades_de_medida WHERE clave = '{$defaultProductData['unidad_de_medida']}'");
            if($result->num_rows > 0){$result = $result->fetch_object(); $umName = $result->descripcion;}            
            
            $producto = array(
                'nombre'=>$defaultProductData['nombre'],
                'codigo'=>$defaultProductData['codigo'],
                'sat_producto_clave'=>$defaultProductData['sat_producto_clave'],
                'um_clave'=>$defaultProductData['unidad_de_medida'],
                'um_name'=>$umName,
            );
            
            $impuesto = array(
                'Importe'=>$impuestosMonto,
                'nombre'=>$impuestosData['impuesto'],
                'descripcion'=>$impuestosData['descripcion'],
                'Base'=>$precio,
                'Impuesto'=>$impuestosData['clave'],
                'TipoFactor'=>$impuestosData['tipo_factor'],
                'TasaOCuota'=>$impuestosData['tasa_cuota'],
            );
            
            $impuestosArplicables = array('Trasladable'=>array($impuestosData['id']=>$impuesto),'Retenible'=>array());

            $array = array(
                'idVenta'=>$datosTicketFromDB['idPos'],
                'ticket'=>$datosTicketFromDB['ticket'],
                'idProducto'=>$defaultProductData['id'],
                'descripcion'=>$defaultProductData['nombre'],
                'cantidad'=>'1',
                'precio'=>$precio,
                'precio_sin_impuestos'=>$precio,
                'descuento'=>'0',
                'descuento_monto'=>'0',
                'descuento_orden_monto'=>'0',
                'impuestos'=>$impuestosData['id'],
                'impuestos_tasa'=>$impuestosData['tasa_cuota'],
                'impuestos_monto'=>$impuestosMonto,
                'status'=>'0',
                'impuestos_aplicables'=> serialize($impuestosArplicables),
                'info_producto'=> serialize($producto),
            );
            
            $detalles = array($array);
            $datosTicketFromDB['detalles_impuestos_aplicables'] = serialize($impuestosArplicables);
           
        }
        
        $importeTotal = 0;
        foreach ($detalles as $detalle){
            $importe = $detalle['precio_sin_impuestos'] * $detalle['cantidad'];
            $descuento = $detalle['descuento_monto'] + $detalle['descuento_orden_monto'];
            
            $importeTotal += $importe - $descuento;
        }        
        
        $datosFactura['num_venta'] = $datosTicketFromDB['id_pos'];
        $datosFactura['subtotal'] = $importeTotal;
        $datosFactura['total'] = $datosTicketFromDB['monto'];
        $datosFactura['total_impuestos_trasladados'] = $datosTicketFromDB['total_impuestos_trasladados'];
        $datosFactura['total_impuestos_retenidos'] = $datosTicketFromDB['total_impuestos_retenidos'];
        $datosFactura['detalles_impuestos_aplicables'] = $datosTicketFromDB['detalles_impuestos_aplicables'];
        
        #Guardar Factura        
        $datosFactura['version_cfdi'] = $settings->_get('version_cfdi');
        $datosFactura['status'] = '1';       
        
        $repo->startTransaction();
        $rs = $repo->save($datosFactura, 'facturas');   
        $idFactura = $repo->getInsertId();
        
        if($rs){
            #Guardar Factura Detalles
            foreach($detalles as $detalle){                //var_dump($detalle);exit;
                $producto = unserialize($detalle['info_producto']);
                //var_dump($producto);exit;
                $importe = $detalle['precio_sin_impuestos'] * $detalle['cantidad'];
                $descuento = $detalle['descuento_monto'] + $detalle['descuento_orden_monto'];
                
                $datosDetalleFactura = array(
                'id_factura'=>$idFactura,
                'nombre'=>$producto['nombre'],
                'descripcion'=>'',
                'cantidad'=>$detalle['cantidad'],
                'precio_unitario'=>$detalle['precio_sin_impuestos'],                    
                'importe'=>$importe - $descuento,
                'objeto_impuesto'=>(empty($producto['objeto_impuesto']))? '02' : $producto['objeto_impuesto'],
                'descuento_monto'=>$descuento,
                'impuestos_aplicables' => $detalle['impuestos_aplicables'],   
                'info_producto'=>$detalle['info_producto']
                #'id_producto'=>$producto['id'],
                #'descuento_detalle'=>'0',                    
                #'impuestos_incluidos'=>$producto['impuestos_incluidos'],
                #'impuestos'=>$producto['impuestos'],
            );   
                
                $rs = $repo->save($datosDetalleFactura, 'facturas_detalles');
                
                if(!$rs){
                   // echo "error";exit;
                    $repo->rollback();
                    return null;
                }
            }           
            
            $repo->commit();
            return $idFactura;
        }else{
            $repo->rollback();
            return null;
        }      
        
        return null;
    }
  
    public function getTable(){
        return $this->table;
    }
}