<div class="box box-primary">
    <div class="box-header with-border">
        <h3 class="box-title"><i class="fa fa-th-large"></i> <?php echo $_translator->_getTranslation(ucfirst($_reporte->getTituloReporte()));?></h3>
        <div class="box-tools pull-right"></div><!-- /.box-tools -->
    </div><!-- /.box-header -->
    <div class="box-body">
        <?php
        $result = $_reporte->getReporte();
        $data = empty($result['data']) ? [] : $result['data'];
        if (count($data) <= 0) {
                echo $_translator->_getTranslation('There is not any data.');
                exit;
        }
        ?>
        <table class="table table-bordered">
            <tbody>
            <tr>
                <td class="text-center"><h2>$ <?php echo $result['ventasMonto']; ?></h2></td>
                <td class="text-center"><h2><?php echo $result['ventasGeneradas']; ?></h2></td>
            </tr>
            <tr>
                <th class="text-center label-success"><?php echo $_translator->_getTranslation('Monto de facturacion') ?></th>
                <th class="text-center label-primary"><?php echo $_translator->_getTranslation('Facturas generadas'); ?></th>
            </tr>
            </tbody>
        </table>
                <br/>
                <a class='btn btn-default' href="<?php echo $_reporte->getStringToSendGET() . '&output=excel'; ?>"><i class="fa fa-file-excel-o"></i> Exportar a excel</a>
                <table id="tblReport" class="table table-striped table-bordered table-condensed table-hover">
                    <thead class="table-header">
                        <tr>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Serie'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Folio'); ?></td>
                            <!--<td class="text-center"><?php //echo $_translator->_getTranslation('Ticket');
                                                        ?></td> -->
                            <td class="text-center"><?php echo $_translator->_getTranslation('Fecha'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Cliente'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Importe'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('IVA'); ?></td>
                            <td class="text-right"><?php echo $_translator->_getTranslation('IEPS'); ?></td>
                            <td class="text-right"><?php echo $_translator->_getTranslation('Total'); ?></td>
                            <td class="text-right"><?php echo $_translator->_getTranslation('Saldo Pendiente'); ?></td>
                            <td class="text-right"><?php echo $_translator->_getTranslation('Sucursal'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Status'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Venta #'); ?></td>
                            <td class="text-center"><?php echo $_translator->_getTranslation('Ticket'); ?></td>
                        </tr>
                    </thead>
                    <tbody>
                        <?php
                        foreach ($data as $row) {
                            $cliente = unserialize(utf8_decode($row['datos_receptor']));
                            if (isset($cliente['Receptor']['nombre'])) {
                                $cliente['Receptor']['Nombre'] = $cliente['Receptor']['nombre'];
                            }
                            if (isset($cliente['Receptor']['rfc'])) {
                                $cliente['Receptor']['Rfc'] = $cliente['Receptor']['rfc'];
                            }

                            /* PARA PCG */

                            $impuestos = unserialize(utf8_decode($row['detalles_impuestos_aplicables']));
                            $ieps = 0;
                            $iva = 0;

                            if ('3.3' == $row['version_cfdi']) {
                                if (isset($impuestos['Trasladable']['2'])) {
                                    $ieps = $impuestos['Trasladable']['2']['Importe'];
                                }
                                if (isset($impuestos['Trasladable']['1'])) {
                                    $iva = $impuestos['Trasladable']['1']['Importe'];
                                }
                            } elseif ('3.2' == $row['version_cfdi']) {
                                if (isset($impuestos['Trasladable']['2'])) {
                                    $ieps = $impuestos['Trasladable']['2']['monto'];
                                }
                                if (isset($impuestos['Trasladable']['1'])) {
                                    $iva = $impuestos['Trasladable']['1']['monto'];
                                }
                            } ?>
                            <tr>
                                <td class="text-center"><?php echo $row['serie']; ?></td>
                                <td class="text-center"><?php echo $row['folio']; ?></td>
                                <!--<td class="text-center"><?php //echo $row['ticket'];
                                                            ?></td>-->
                                <!--<td class="text-center"><?php echo $row['uuid']; ?></td>-->
                                <td class="text-center"><?php echo $row['fecha_timbrado_solo_fecha']; ?></td>
                                <td class="text-center"><?php echo htmlentities($cliente['Receptor']['Nombre']); ?></td>
                                <td class="text-right"><?php echo number_format($row['subtotal'], 2); ?></td>
                                <td class="text-right"><?php echo number_format($iva, 2); ?></td>
                                <td class="text-right"><?php echo number_format($ieps, 2); ?></td>
                                <td class="text-right"><?php echo number_format($row['total'], 2); ?></td>
                                <td class="text-right"><?php echo number_format($row['saldo_pendiente'], 2); ?></td>
                                <td class="text-center"><?php echo $row['sucursalName']; ?></td>
                                <td class="text-center"><?php echo $row['statusName']; ?></td>
                                <td class="text-center"><?php echo $row['num_venta']; ?></td>
                                <td class="text-center"><?php echo $row['ticket']; ?></td>
                            </tr><?php
                                } ?>
                    </tbody>
                </table>
</div>
<script type="text/javascript" language="javascript">
    $('#tblReport').DataTable({
        paginate: false,
        filter: true,
        fixedHeader: true,
        aaSorting: [],
        dom: 'Bfrtip',
        buttons: [
            'excel'
        ]
    });


    $('#tblReport')
        .removeClass('display')
        .addClass('table table-striped table-bordered');
</script>